*------------------------------------------------------------------------------
*- Version....: Sage Pro ERP 2010
*- File Name..: $Workfile: FIXBALS.PRG $
*- VCS Level..: $Revision: 1 $
*- Last Update: $Date: 8/14/08 9:18p $
*------------------------------------------------------------------------------
*- Copyright (C) 2009 Sage Software, Inc.  All Rights Reserved.
*------------------------------------------------------------------------------
*- App ID.....: TOOLS
*- App Name...: Tools
*------------------------------------------------------------------------------
*- Synopsis...: Tools to fix GL Balances
*------------------------------------------------------------------------------
*- Called By..: Pro Tools menu
*------------------------------------------------------------------------------
CLEAR
CLOSE DATABASES
SET TALK OFF
SET BELL OFF
SET ALTERNATE TO GLBLREC.OUT
SET ALTERNATE ON

PRIVATE ln_errors, ;
        lc_numpic, ;
        lc_curyr, ;
        lc_fyperds, ;
        lc_glcompid, ;
        lc_Warning

STORE 0 TO ln_errors
STORE "999,999,999.99" TO lc_numpic

ln_NextRec  =  20070    && Next record.
ln_PrevRec  =  20080    && Previous record.
ln_TopRec   =  20090    && Top record.
lc_Warning  = ""

go_sql.m_OpenTable("a_sycins", "sycinst", .f., .f.)

IF VAL(SUBSTR(a_sycins->sversn, 2)) > 3301.00
  TEXT TO lc_Warning TEXTMERGE NOSHOW
You are using Sage Pro ERP version 7.4 or greater, Build <<ALLTRIM(a_sycins->sversn)>>.

Starting from Sage Pro ERP version 7.4, you need to run this 
from the system manager menu. 
To do this, Load Sage Pro ERP, go to System Manager and choose 
Transaction, System Recovery, Recalculate GL Account Balances.
  ENDTEXT

  MESSAGEBOX(lc_warning, 0+16)
  RETURN
ENDIF

go_Sql.cmpA_sycins.m_CloseTable()

*-- Display warning
? "!!!!!!!!!! WARNING !!! DANGER !!! WARNING !!!!!!!!!!"
?
? "====== !BACK UP! BEFORE RUNNING THIS PROGRAM! ======"
?
? "This program may make SIGNIFICANT changes to your"
? "General Ledger Balances file and if you don't have a"
? "way to undo what you are about to do, this could be a"
? "BIG BIG BIG mistake!!"
?
? "This program makes some assumptions on the validity of"
? "some databases and brings the General Ledger Balances"
? "file into agreement with those files.  YOU ARE RESPONSIBLE"
? "for printing all financial reports and verifying their"
? "validity before and after you run this program!"
?
? "To cancel this process, PRESS ENTER NOW!"
?

*-- Get the GL data path from SYCDATA
go_SQL.m_OpenTable("a_sycdat", "sycdata", .f., .f., "compid1", .f.)
go_SQL.so_CurrentAlias.m_SetOrder("compid1")

lc_compid = SPACE(LEN(a_sycdat->compid))

*-- Find out which company the user wants to check
@ 20,5 SAY "Company number:" GET lc_compid
READ
CLEAR

go_SQL.so_CurrentAlias.m_Seek(lc_compid+"GL")

IF NOT go_SQL.so_CurrentAlias.m_IsFound()
    ? IIF(EMPTY(lc_compid),"","Company "+lc_compid+" not found")
    CLOSE ALTERNATE
    CLOSE DATABASES
    WAIT WINDOW
    WAIT CLEAR
    RETURN
ENDIF

STORE ALLTRIM(adosdbf) TO lc_glpath
STORE compid TO lc_glcompid

*-- Open company table
go_SQL.m_OpenTable("a_syccom", "syccomp", .f., .f., "compid", .f.)
go_SQL.so_CurrentAlias.m_SetOrder("compid")

IF go_Sql.sc_SqlType <> "FD"
  go_SQL.so_CurrentAlias.m_Seek(lc_compid)
  *-- Set database to be used for SQL
  = go_Sql.m_SetDatabase(ALLTRIM(a_syccom->dbname))
ENDIF

lf_glstru = IIF(go_Sql.sc_SqlType <> "FD", ALLTRIM(a_syccom->dbname) + "..glstru", lc_glpath + "glstru" + lc_glcompid)
lf_glacnt = IIF(go_Sql.sc_SqlType <> "FD", ALLTRIM(a_syccom->dbname) + "..glacnt", lc_glpath + "glacnt" + lc_glcompid)
lf_glbtch = IIF(go_Sql.sc_SqlType <> "FD", ALLTRIM(a_syccom->dbname) + "..glbtch", lc_glpath + "glbtch" + lc_glcompid)
lf_glbals = IIF(go_Sql.sc_SqlType <> "FD", ALLTRIM(a_syccom->dbname) + "..glbals", lc_glpath + "glbals" + lc_glcompid)
lf_glhent = IIF(go_Sql.sc_SqlType <> "FD", ALLTRIM(a_syccom->dbname) + "..glhent", lc_glpath + "glhent" + lc_glcompid)
lf_gldent = IIF(go_Sql.sc_SqlType <> "FD", ALLTRIM(a_syccom->dbname) + "..gldent", lc_glpath + "gldent" + lc_glcompid)

*-- Get Account Structure info from GLSTRUxx
go_SQL.m_OpenTable("a_glstru1", lf_glstru, .f., .f., "segid", .f.)
go_SQL.so_CurrentAlias.m_SetOrder("segid")

STORE 0 to ln_segs, ln_acdplen

go_SQL.so_CurrentAlias.m_ScanBegin("F", "locked = .t.")

DO WHILE go_SQL.so_CurrentAlias.m_Scan()
    STORE ln_segs + 1 TO ln_segs
    DIMENSION la_glstru[ln_segs,2]
    STORE seglen  TO la_glstru[ln_segs,1]
    STORE segstrt TO la_glstru[ln_segs,2]
ENDDO

go_SQL.so_CurrentAlias.m_ScanEnd()

IF ln_segs > 1
    STORE la_glstru[1,1]+la_glstru[2,1]+1 TO ln_acdplen
ENDIF

*-- Find out whether or not Retained Earnings is Departmentalized
*-- as well as get the default Retained Earnings account number
go_SQL.m_OpenTable("a_sysdat", "sysdata", .f., .f., "", .f.)

STORE .F. TO ll_depre
STORE .F. TO ll_consol

go_SQL.so_CurrentAlias.m_Locate("FOR sysid = 'GL" + lc_compid + "'")

IF SUBSTR(link,11,1) == "Y" .OR. SUBSTR(str5,15,1) == "Y"
    STORE .T. TO ll_depre
ENDIF

IF SUBSTR(str5,10,1) == "Y"
    STORE .T. TO ll_consol
ENDIF

STORE SUBSTR(link,12,24) TO lc_retearn

*-- Get the current year and number of periods per year
*-- from SYCCOMP
go_SQL.m_TableChangeCurrent("a_syccom")
go_SQL.so_CurrentAlias.m_Locate("FOR compid = '" +  lc_compid + "'")

STORE curyr TO lc_curyr
STORE STR(fyperds,2,0) TO lc_fyperds

? "Checking company "+lc_compid+" - "+company
? "The current period is "+curprd+" of fiscal year "+curyr
? "There are "+lc_fyperds+" periods in the current fiscal year"
?

go_SQL.m_CloseTableAll()

*-- open databases for reconciliation
DO l_opnfiles

*-- Check for blank records
DO l_chkblnks

*-- Check for duplicate records
IF go_SQL.sc_SQLTypeMain = "F"
  DO l_chkdupes_vfp
ELSE
  DO l_chkdupes_sql
ENDIF

*-- Check for existence of all required records
IF go_SQL.sc_SQLTypeMain = "F"
  DO l_chkreq_vfp
ELSE
  DO l_chkreq_sql
ENDIF

*-- Check for unbalanced entries in GLDENT
DO l_chkdent

*-- Check Period-to-date activity against GLDENT
*-- but only if it's not a consolidation company
DO CASE 
  CASE ll_consol
    *-- Do Nothing
  CASE go_SQL.sc_SqlTypeMain = "F"
    DO l_dentrec_vfp
  OTHERWISE
    DO l_dentrec_sql
ENDCASE

*-- Check the Year-to-date balances against the
*-- Period-to-date balances
IF go_SQL.sc_SQLTypeMain = "F"
 DO l_chkytd_vfp
ELSE
 DO l_chkytd_sql
ENDIF

*-- Check beginning and ending balance of each record
IF go_SQL.sc_SQLTypeMain = "F"
  DO l_chkbals_vfp
ELSE
  DO l_chkbals_sql
ENDIF

*-- Check file totals
DO l_chkttls

*-- Output total number of errors if any
IF ln_errors > 0
    ?  IIF(ln_errors > 1,"There are ","There is ")
    ?? ALLTRIM(STR(ln_errors))
    ?? IIF(ln_errors > 1," errors in "," error in ")
    ?? dbf("a_glbals")
ELSE
    ?  "No errors were found in "+dbf()
ENDIF

?
? "The output has been written to "+FULLPATH("glblrec.out")

WAIT WINDOW
WAIT CLEAR

go_SQL.m_CloseTableAll()

CLOSE ALTERNATE
CLOSE DATABASES

RETURN
*--------------------------- End of main program block - procedures follow

*--------------------------- Procedure l_opnfiles
PROCEDURE l_opnfiles

? "---------- Opening files"
?

*-- SYCDFIS is used to check for required records in GLBALSxx
go_SQL.m_OpenTable("a_sycdfis", "sycdfis", .f., .f., "compid1", .f.)
go_SQL.so_CurrentAlias.m_SetOrder("compid1")

*-- GLACNTxx is used for account description as well as type
*-- Ignore Statistical accounts and records marked for deletion
go_SQL.m_OpenTable("a_glacnt", lf_glacnt, .f., .f., "glacnt", .f.)
go_SQL.so_CurrentAlias.m_SetOrder("glacnt")

*-- GLACNTxx gets opened again so that it can be used to check for
*-- all required records in GLBALSxx.  Ignore Statistical accounts
*-- and records marked for deletion
go_SQL.m_OpenTable("a_glacnt2", lf_glacnt, .f., .t., "glacnt", .f.)
go_SQL.so_CurrentAlias.m_SetOrder("glacnt")

*-- GLBTCHxx is used to detect Beginning Balances batches
*-- Ignore records marked for deletion
go_SQL.m_OpenTable("a_glbtch", lf_glbtch, .f., .f., "batchno", .f.)
go_SQL.so_CurrentAlias.m_SetOrder("batchno")

*-- GLHENTxx is used to detect Year-End Closing entries
go_SQL.m_OpenTable("a_glhent", lf_glhent, .f., .f., "batchno1", .f.)
go_SQL.so_CurrentAlias.m_SetOrder("batchno1")

*-- GLBALSxx is the primary patient
*-- Ignore Statistical accounts and records marked for deletion
go_SQL.m_OpenTable("a_glbals", lf_glbals, .f., .f., "glacnt1", .f.)
go_SQL.so_CurrentAlias.m_SetOrder("glacnt1")

*-- GLBALSxx gets opened a 2nd time so that the Income Statement
*-- accounts can be sumed for next year's beginning balance of
*-- Retained Earnings accounts without moving the record pointer
*-- in the 1st instance of GLBALSxx.  Ignore Statistical accounts
*-- and records marked for deletion
go_SQL.m_OpenTable("a_glbals2", lf_glbals, .f., .t., "glacnt1", .f.)
go_SQL.so_CurrentAlias.m_SetOrder("glacnt1")

*-- GLDENTxx gets opened so that it can be reconciled with GLBALSxx
*-- Ignore records marked for deletion
go_SQL.m_OpenTable("a_gldent", lf_gldent, .f., .f., "glacnt", .f.)
go_SQL.so_CurrentAlias.m_SetOrder("glacnt")

IF go_SQL.sc_SQLTypeMain = "F"

  go_SQL.cmpa_sycdfis.m_SetFilter("NOT DELETED() AND compid = '" + lc_glcompid + ;
    "' AND VAL(LEFT(yearprd,4)) >= VAL('" + lc_curyr + "') - 1")
  go_SQL.cmpa_glacnt.m_SetFilter("NOT DELETED()")
  go_SQL.cmpa_glacnt2.m_SetFilter("NOT DELETED()")
  go_SQL.cmpa_glbtch.m_SetFilter("NOT DELETED()")
  go_SQL.cmpa_glhent.m_SetFilter("NOT DELETED()")
  go_SQL.cmpa_glbals.m_SetRelation("glacnt", "a_glacnt", .f.)
  go_SQL.cmpa_glbals.m_SetFilter("LEFT(a_glacnt->gltype,1) <> 'Y' AND NOT DELETED()")
  go_SQL.cmpa_glbals2.m_SetRelation("glacnt", "a_glacnt", .f.)
  go_SQL.cmpa_glbals2.m_SetFilter("LEFT(a_glacnt->gltype,1) <> 'Y' AND NOT DELETED()")
  go_SQL.cmpa_gldent.m_SetRelation("batchno+glseqno", "a_glhent", .f.)
  go_SQL.cmpa_gldent.m_SetRelation("batchno", "a_glbtch", .t.)
  go_SQL.cmpa_gldent.m_SetFilter("LEFT(a_glacnt->gltype,1) <> 'Y' AND NOT DELETED()")
ENDIF

RETURN
*------------------------ End procedure l_opnfiles

*------------------------ Procedure l_chkblnks
PROCEDURE l_chkblnks

PRIVATE ln_emptyacct
STORE 0 TO ln_emptyacct

go_SQL.m_TableChangeCurrent("a_glbals")

*-- Let the user know what's going on
? "---------- Checking for blank records"
?

ln_emptyacct = go_SQL.cmpA_glbals.m_Count("FOR EMPTY(glacnt)")

*-- Are there any blank records?
IF ln_emptyacct > 0
    go_SQL.cmpA_glbals.m_DeleteBulk("F", "EMPTY(glacnt)")

    STORE ln_errors+ln_emptyacct TO ln_errors
    ?  IIF(ln_emptyacct > 1,"There are ","There is ")
    ?? +ALLTRIM(STR(ln_emptyacct))
    ?? IIF(ln_emptyacct > 1," records "," record ")
    ?? "with no account number"
    ?
ENDIF

RETURN
*------------------------ End procedure l_chkblnks

PROCEDURE l_chkdupes_vfp

*-- Let the user know what's going on
? "---------- Checking for duplicate records"
?

go_SQL.m_TableChangeCurrent("a_glbals")
LOCATE

*-- Move to the 1st non-blank record
DO WHILE EMPTY(glacnt)
    SKIP 1
ENDDO

*-- Step through GLBALSxx one-at-a-time and check for more than one
*-- record that have the same GLACNT and YEARPRD fields
DO WHILE .NOT. EOF()

    
    *-- Let the user know which account we're on
    WAIT WINDOW NOWAIT ALLTRIM(a_glacnt->glacnt)+" "+a_glacnt->gldesc

    *-- Store the current records' account and period to 
    *-- memory variables
    STORE glacnt+yearprd TO lc_key
    STORE 0 TO ln_dupes

    *-- With the memory variables established, go to the next record
    *-- and see if the GLACNT and YEARPRD fields are the same
    SKIP 1
    
    DO WHILE glacnt+yearprd == lc_key
        STORE ln_dupes + 1 TO ln_dupes
        DELETE
        SKIP 1
    ENDDO
    
    *-- If duplicate records were found, let the user know which
    *-- account and period and how many
    IF ln_dupes > 0
        STORE ln_errors+ln_dupes TO ln_errors
        ?  ALLTRIM(LEFT(lc_key,LEN(lc_key)-6))
        ?? " - "+SUBSTR(lc_key,25,4)+"-"
        ?? RIGHT(lc_key,2)+" has "+ALLTRIM(STR(ln_dupes))
        ?? " duplicate "+IIF(ln_dupes > 1,"records","record") 
        ?
    ENDIF

ENDDO

RETURN
*------------------------ End procedure l_chkdupes_vfp

*------------------------ Procudure l_chkdupes_sql
PROCEDURE l_chkdupes_sql

 PRIVATE la_glbals, ;
         ll_dup

 DECLARE la_glbals(1,3)
 
 ll_dup = .f.

*-- Let the user know what's going on
? "---------- Checking for duplicate records"
?

go_SQL.m_SQLSelect("a_glbals.glacnt, yearprd, count(a_glbals.glacnt + yearprd) FROM " + ;
                  lf_glbals + " a_glbals " + ;
                  " INNER JOIN " + lf_glacnt + " a_glacnt " + ;
                  " ON a_glbals.glacnt = a_glacnt.glacnt " + ;
                  " WHERE LEFT(a_glacnt.gltype, 1) <> 'Y' " + ;
                  " GROUP BY a_glbals.glacnt,yearprd ORDER BY a_glbals.glacnt, yearprd", ;
                  "ARRAY", ;
                  "la_glbals", ;
                  "") 

FOR ln_count = 1 TO ALEN(la_glbals,1)
  ln_dupes = la_glbals[ln_count,3] - 1

  IF ln_dupes > 0
    ll_dup = .t. 
    lc_key = la_glbals[ln_count,1] + la_glbals[ln_count,2]
    STORE ln_errors + ln_dupes TO ln_errors
    ?  ALLTRIM(LEFT(lc_key,LEN(lc_key)-6))
    ?? " - "+SUBSTR(lc_key,25,4)+"-"
    ?? RIGHT(lc_key,2)+" has "+ALLTRIM(STR(ln_dupes))
    ?? " duplicate "+IIF(ln_dupes > 1,"records","record") 
    ?
  ENDIF

ENDFOR

IF ll_dup
  go_SQL.m_Execute("DELETE FROM " + lf_glbals + " WHERE id_col <> " + ;
                   "(SELECT MIN(a_glbals1.id_col) FROM " + lf_glbals + " a_glbals1 " + ;
                  " INNER JOIN " + lf_glacnt + " a_glacnt " + ;
                  " ON a_glbals1.glacnt = a_glacnt.glacnt " + ;
                  " WHERE LEFT(a_glacnt.gltype, 1) <> 'Y' AND " + ;
                  " a_glbals1.glacnt = " + lf_glbals + ".glacnt AND " + ;
                  " a_glbals1.yearprd = " + lf_glbals + ".yearprd " + ;
                  " GROUP BY a_glbals1.glacnt,yearprd)")
ENDIF

go_SQL.m_TableChangeCurrent("a_glbals")

RETURN
*------------------------ End procedure l_chkdupes_sql

*------------------------ Procedure l_chkreq_vfp
PROCEDURE l_chkreq_vfp

*-- Let the user know what's going on
? "---------- Checking for all required records"
?

go_SQL.m_TableChangeCurrent("a_glacnt2")
LOCATE

*-- Step through GLACNTxx and check to see if each account has
*-- one record in GLBALSxx for each record in SYCDFIS
SCAN FOR LEFT(gltype,1) <> "Y"
    
    *-- Let the user know what's going on
    WAIT WINDOW NOWAIT ALLTRIM(glacnt)+" "+gldesc
    
    *-- Start at the top of SYCDFIS
    SELECT a_sycdfis
    LOCATE
    SELECT a_glacnt2
    
    *-- Step through SYCDFIS and check for the existence of
    *-- a record in GLBALSxx that corresponds to the current
    *-- record in SYCDFIS as well as the current record in
    *-- GLACNTxx
    DO WHILE .NOT. EOF("a_sycdfis")
        
        *-- Find the record in GLBALSxx
        *-- If it's not there, tell the user
        IF .NOT. SEEK(glacnt+a_sycdfis->yearprd,"a_glbals")
            STORE ln_errors + 1 TO ln_errors
            ?  ALLTRIM(glacnt)+" - "
            ?? LEFT(a_sycdfis->yearprd,4)+"-"
            ?? RIGHT(a_sycdfis->yearprd,2)+" is missing"
            ?
            SELECT a_glbals
            APPEND BLANK
            REPLACE glacnt  WITH a_glacnt2->glacnt,  ;
                    yearprd WITH a_sycdfis->yearprd, ;
                    adddate WITH DATE(),             ;
                    addtime WITH TIME(),             ;
                    adduser WITH "ADMN"
            SELECT a_glacnt2
        ENDIF
        
        *-- Go to the next record in SYCDFIS and start the loop over
        SKIP 1 IN a_sycdfis
    ENDDO

ENDSCAN

RETURN
*------------------------ End Procedure l_chkreq_vfp

*------------------------ Procedure l_chkreq_sql
PROCEDURE l_chkreq_sql

*-- Let the user know what's going on
? "---------- Checking for all required records"
?

lc_tmpf2 = go_SQL.m_GetTempTableName(2)
lc_tmpf3 = go_SQL.m_GetTempTableName(3, "F")

    go_SQL.m_Execute("SELECT a_glacnt.glacnt AS glacnt, " + ;
                     "a_sycdfi.yearprd AS yearprd, " + ;
                     "0.0000 AS fybgbal, " + ;
                     "0.0000 AS ptddr, " + ;
                     "0.0000 AS ptdcr, " + ;
                     "0.0000 AS ytddr, " + ;
                     "0.0000 AS ytdcr, " + ;
                     "0.0000 AS yeclose, " + ;
                     "'ADMN' AS adduser, " + ;
                     "CTOD('" + DTOC(DATE()) + "') AS adddate, " + ;
                     "'" + TIME() + "' AS addtime, " + ;
                     "'ADMN' AS lckuser, " + ;
                     "' ' AS lckstat, " + ;
                     "CTOD('" + DTOC(DATE()) + "') AS lckdate, " + ;
                     "'" + TIME() + "' AS lcktime " + ;
                     " INTO " + lc_tmpf2 + ;
                     " FROM " + ;
                     lf_glacnt + " a_glacnt CROSS JOIN " + ;
                     go_SQL.cmpa_sycdfis.sc_TableNameFull + ;
                     " a_sycdfi " + ;
                     " WHERE LEFT(a_glacnt->gltype,1) <> 'Y' AND " + ;
                     " a_sycdfi.compid = '" + lc_glcompid + "' AND " + ;
                     " VAL(LEFT(yearprd,4)) >= VAL('" + lc_curyr + "') - 1 " + ;
                     " AND a_glacnt.glacnt + a_sycdfi.yearprd NOT IN " + ;
                     " (SELECT a_glbals.glacnt + a_glbals.yearprd FROM " + ;
                     go_SQL.cmpa_Glbals.sc_TableNameFull + " a_glbals)")

    *-- Append the missing glacnt+yearprd combination into GLBALS
    go_SQL.cmpa_Glbals.m_SQLAppendFrom(lc_tmpf2)

    go_SQL.m_SQLSelect("a_tmpf2.* FROM " + ;
       lc_tmpf2 + " a_tmpf2", ;
       "TABLE", ;
       lc_tmpf3)
    go_SQL.so_currentalias.m_CloseTable()

    go_SQL.m_DropTable(lc_Tmpf2)

    = g_opnfl(lc_tmpf3, "a_tmpf3", .t., .f., "", .f., "F")
    
SCAN
  STORE ln_errors + 1 TO ln_errors
  ?  ALLTRIM(glacnt)+" - "
  ?? LEFT(yearprd,4)+"-"
  ?? RIGHT(yearprd,2)+" is missing"
  ?
ENDSCAN

go_SQL.m_DropTable(lc_tmpf3, , "F")
go_SQL.m_TableChangeCurrent("a_glacnt")

RETURN
*------------------------ End Procedure l_chkreq_sql

*------------------------ Procedure l_chkdent
PROCEDURE l_chkdent

*-- Let the user know what's going on
?  "---------- Checking for unbalanced batches in "

?? IIF(go_SQL.sc_SQLTypeMain = "F", "GLDENT" + ALLTRIM(lc_glcompid) + ".DBF", ;
       go_SQL.cmpA_gldent.sc_tableNameFull)
?

go_SQL.m_SQLSelect("MAX(batchno) as batchno, " + ;
       "SUM(IIF(credit = .t., glamnt, 0000000000000.00000)) AS bttotcr, " + ;
       "SUM(IIF(credit = .t., 0000000000000.00000, glamnt)) AS bttotdr " + ;
       " FROM " + go_SQL.cmpA_gldent.sc_tableNameFull + " a_gldent " + ;
       " GROUP BY batchno", ;
       "TABLE", ;
       go_SQL.m_getTempTableName(1, "F"))

go_SQl.so_Currentalias.m_CloseTable()

go_SQL.m_OpenTable("a_tmpf1", go_SQL.m_getTempTableName(1, "F"), .f., .f., "", .f., "F")

*-- Go to the 1st record
GO TOP

SCAN
    *-- Tell the user which batch is being examined
    WAIT WINDOW NOWAIT "Batch Number "+ batchno

    *-- Batch doesn't balance
    IF bttotdr <> bttotcr
        STORE ln_errors + 1 TO ln_errors
        ?  "Batch number "+ batchno
        ?? "         Debits        Credits     Difference"
        ?  SPACE(19)
        ?? "---------------------------------------------"
        ?  SPACE(19)
        ?? bttotdr PICTURE lc_numpic AT 20
        ?? bttotcr PICTURE lc_numpic AT 35
        ?? bttotdr - bttotcr PICTURE lc_numpic AT 50
        ?
    ENDIF

ENDSCAN

*-- Clear wait window
WAIT CLEAR

go_SQL.m_DropTable(go_SQL.m_getTempTableName(1, "F"), , "F")

go_SQL.m_TableChangeCurrent("a_gldent")

RETURN
*------------------------ End procedure l_chkdent

*------------------------ Procedure l_dentrec_vfp
PROCEDURE l_dentrec_vfp

*-- Let the user know what's going on
? "---------- Reconciling GLBALS" + ALLTRIM(lc_glcompid) + ".DBF"
?? " with GLDENT" + ALLTRIM(lc_glcompid) + ".DBF"

?

go_SQL.m_TableChangeCurrent("a_glbals")
LOCATE

DO WHILE .NOT. EOF()
    
    *-- Since this loop takes considerably longer than the others,
    *-- we should let the user know which account AND which period
    *-- we're working on
    WAIT WINDOW NOWAIT ALLTRIM(glacnt)+" - Period "+RIGHT(yearprd,2)+;
      " of Fiscal Year "+LEFT(yearprd,4)

    *-- Initialize memory variables back to 0.00
    STORE 0.00 TO ln_tdentdr, ln_tdentcr, ln_tyeclose
    
    *-- Variables for the current record for GLDENTxx to reference
    STORE glacnt TO lc_glacnt
    STORE yearprd TO lc_yearprd

    *-- Get totals from gldent
    SELECT a_gldent

    *-- Position the record pointer at the 1st transaction 
    *-- for this account
    SEEK lc_glacnt
    
    *-- Step through GLDENTxx for all transactions for this account
    *-- except Beginning Balance trasactions
    SCAN FOR yearprd == lc_yearprd .AND. a_glbtch->btype <> "B" ;
      WHILE glacnt==lc_glacnt
        
        *-- Year-End closing entry
        IF a_glhent->trtype == "Y"
            ln_tyeclose = ln_tyeclose + ;
              IIF(credit,-glamnt,+glamnt)
        ELSE
            *-- Normal Entry
            IF credit
                ln_tdentcr = ln_tdentcr + glamnt
            ELSE
                ln_tdentdr = ln_tdentdr + glamnt
            ENDIF
        ENDIF

    ENDSCAN

    *-- compare gldent with glbals ptd numbers and yeclose
    SELECT a_glbals

    IF ABS(ln_tdentdr-ptddr) >= 0.01 .OR. ;
       ABS(ln_tdentcr-ptdcr) >= 0.01 .OR. ;
       ABS(ln_tyeclose-yeclose) >= 0.01

        STORE ln_errors+1 TO ln_errors

        ? "Account "+ALLTRIM(glacnt)+" - "+a_glacnt->gldesc
        ?
        ? SUBSTR(yearprd,1,4)+"-"+SUBSTR(yearprd,5,2)
        ?? "        PTD debits     PTD credits        Year End      Net Change"
        ? "GLBALS"+lc_glcompid+":"
        ?? ptddr   PICTURE lc_numpic AT 11
        ?? ptdcr   PICTURE lc_numpic AT 27
        ?? yeclose PICTURE lc_numpic AT 43
        ?? ptddr-ptdcr+yeclose PICTURE lc_numpic AT 59
        ? "GLDENT"+lc_glcompid+":"
        ?? ln_tdentdr PICTURE lc_numpic AT 11
        ?? ln_tdentcr PICTURE lc_numpic AT 27
        ?? ln_tyeclose PICTURE lc_numpic AT 43
        ?? ln_tdentdr-ln_tdentcr+ln_tyeclose PICTURE lc_numpic AT 59
        ?  SPACE(11)+REPLICATE("=",62)
        ? "Difference:"
        ?? ptddr-ln_tdentdr PICTURE lc_numpic AT 11
        ?? ptdcr-ln_tdentcr PICTURE lc_numpic AT 27
        ?? yeclose-ln_tyeclose PICTURE lc_numpic AT 43
        ?? (ptddr-ptdcr+yeclose)-(ln_tdentdr-ln_tdentcr+ln_tyeclose) ;
           PICTURE lc_numpic AT 59
        ?
        REPLACE ptddr   WITH ln_tdentdr, ;
                ptdcr   WITH ln_tdentcr, ;
                yeclose WITH ln_tyeclose
    ENDIF

    *-- On to the next record and do the loop over again
    SKIP 1    

ENDDO

RETURN
*------------------------ End procedure l_dentrec_vfp

*------------------------ Procedure l_dentrec_sql
PROCEDURE l_dentrec_sql

*-- Let the user know what's going on
? "---------- Reconciling " + go_SQL.cmpA_glbals.sc_tableNameFull 
?? " with " + go_SQL.cmpA_gldent.sc_tableNameFull
?

lc_tmpf1 = go_SQL.m_GetTempTableName(1)
lc_tmpf2 = go_SQL.m_GetTempTableName(2)

go_SQL.m_SQLSelect(" a_gldent.glacnt, a_gldent.yearprd, " + ;
" SUM( IIF(a_gldent.credit = .t. AND a_glhent.trtype <> 'Y', glamnt, 0.00)) AS tdentcr, " + ;
" SUM( IIF(a_gldent.credit = .f. AND a_glhent.trtype <> 'Y', glamnt, 0.00)) AS tdentdr, " + ;
" SUM( IIF(a_glhent.trtype = 'Y' , IIF(a_gldent.credit = .t., glamnt * -1, glamnt), 0.00)) AS tyeclose " + ;
" FROM " + go_SQL.cmpA_gldent.sc_TableNameFull + " a_gldent " + ;
" INNER JOIN " + go_SQL.cmpA_glbals.sc_TableNameFull + " a_glbals " + ;
" ON a_glbals.glacnt = a_gldent.glacnt AND " + ;
"    a_glbals.yearprd = a_gldent.yearprd " + ;
" INNER JOIN " + go_SQL.cmpA_glbtch.sc_TableNameFull + " a_glbtch " + ;
" ON a_glbtch.batchno = a_gldent.batchno " + ;
" INNER JOIN " + go_SQL.cmpA_glhent.sc_TableNameFull + " a_glhent " + ;
" ON a_glhent.batchno = a_gldent.batchno AND " + ;
"    a_glhent.glseqno = a_gldent.glseqno " + ;
" INNER JOIN " + go_SQL.cmpA_glacnt.sc_TableNameFull + " a_glacnt " + ;
" ON a_glbals.glacnt = a_glacnt.glacnt " + ;
" WHERE LEFT(a_glacnt.gltype, 1) <> 'Y' AND " + ;
" a_glbtch.btype <> 'B' " + ;
" GROUP BY a_gldent.glacnt, a_gldent.yearprd", ;
"SQL TABLE", ;
lc_tmpf1)

go_SQL.so_CurrentAlias.m_CloseTable()

go_SQL.m_SQLSelect(" a_tmpf1.glacnt, a_glacnt.gldesc, a_tmpf1.yearprd, " + ;
                   " a_glbals.ptddr, a_glbals.ptdcr, a_glbals.yeclose, " + ;
                   " a_tmpf1.tdentdr, a_tmpf1.tdentcr, a_tmpf1.tyeclose " + ;
                   " FROM " + go_SQL.cmpA_glbals.sc_TableNameFull + " a_glbals " + ;
                   " INNER JOIN " + go_SQL.cmpA_glacnt.sc_TableNameFull + " a_glacnt " + ;
                   " ON a_glacnt.glacnt = a_glbals.glacnt " +  ;
                   " INNER JOIN " + lc_tmpf1 + " a_tmpf1 " + ;
                   " ON a_tmpf1.glacnt = a_glbals.glacnt AND " +  ;
                   "    a_tmpf1.yearprd = a_glbals.yearprd " + ;
                   " WHERE ABS(a_tmpf1.tdentdr - a_glbals.ptddr) >= 0.01 OR " + ;
                   "       ABS(a_tmpf1.tdentcr - a_glbals.ptdcr) >= 0.01 OR " + ;
                   "       ABS(a_tmpf1.tyeclose - a_glbals.yeclose) >= 0.01 ", ;
                   "SQL TABLE", ;
                   lc_tmpf2)

go_SQL.so_CurrentAlias.m_CloseTable()


go_SQL.m_Execute(" UPDATE " + go_SQL.cmpA_glbals.sc_TableNameFull + ;
                 " SET ptddr = tdentdr, " + ;
                 "     ptdcr = tdentcr, " + ;
                 "     yeclose = tyeclose " + ;
                 " FROM " + go_SQL.cmpA_glbals.sc_TableNameFull + " a_glbals " + ;
                 " INNER JOIN " + lc_tmpf2 + " a_tmpf2 " + ;
                 " ON a_glbals.glacnt = a_tmpf2.glacnt AND " + ;
                 "    a_glbals.yearprd = a_tmpf2.yearprd", "")

= g_opnfl(lc_tmpf2, "a_tmpf2", .t., .f.)

go_SQL.m_TableChangeCurrent("a_tmpf2")

go_SQL.cmpA_tmpf2.m_ScanBegin("F", ".t. = .t.")
DO WHILE go_SQL.cmpA_tmpf2.m_ScanBulk()
  STORE ln_errors+1 TO ln_errors

  ? "Account "+ALLTRIM(glacnt) + " - " + gldesc
  ?
  ? SUBSTR(yearprd,1,4) + "-" + SUBSTR(yearprd,5,2)
  ?? "        PTD debits     PTD credits        Year End      Net Change"
  ? "GLBALS" + lc_glcompid + ":"
  ?? ptddr   PICTURE lc_numpic AT 11
  ?? ptdcr   PICTURE lc_numpic AT 27
  ?? yeclose PICTURE lc_numpic AT 43
  ?? ptddr - ptdcr + yeclose PICTURE lc_numpic AT 59
  ? "GLDENT" + lc_glcompid + ":"
  ?? tdentdr PICTURE lc_numpic AT 11
  ?? tdentcr PICTURE lc_numpic AT 27
  ?? tyeclose PICTURE lc_numpic AT 43
  ?? tdentdr - tdentcr + tyeclose PICTURE lc_numpic AT 59
  ?  SPACE(11)+REPLICATE("=",62)
  ? "Difference:"
  ?? ptddr - tdentdr PICTURE lc_numpic AT 11
  ?? ptdcr - tdentcr PICTURE lc_numpic AT 27
  ?? yeclose - tyeclose PICTURE lc_numpic AT 43
  ?? (ptddr - ptdcr + yeclose) - (tdentdr - tdentcr + tyeclose) ;
  PICTURE lc_numpic AT 59
  ?

ENDDO
go_SQL.cmpA_tmpf2.m_ScanEnd()

go_SQL.cmpA_tmpf2.m_CloseTable()
go_SQL.m_DropTable(lc_tmpf1)
go_SQL.m_DropTable(lc_tmpf2)

RETURN
*------------------------ End procedure l_dentrec_sql

*------------------------ Procedure l_chkytd_vfp
PROCEDURE l_chkytd_vfp

*-- Let the user know what's going on
? "---------- Checking continuity of Year-to-date balances"
?

go_SQL.m_TableChangeCurrent("a_glbals")
LOCATE

DO WHILE .NOT. EOF()

    *-- Let the user know which account we're on
    WAIT WINDOW NOWAIT ALLTRIM(glacnt)+" "+a_glacnt->gldesc

    STORE LEFT(yearprd,4) TO lc_year
    STORE 0 TO ln_ytddr 
    STORE 0 TO ln_ytdcr

    SCAN WHILE LEFT(yearprd,4) == lc_year

        IF ln_ytddr+ptddr<>ytddr .OR. ;
           ln_ytdcr+ptdcr<>ytdcr

            ln_errors = ln_errors + 1

            ? "Account "+ALLTRIM(glacnt)+" - "+a_glacnt->gldesc
            ?
            ? SUBSTR(yearprd,1,4)+"-"+SUBSTR(yearprd,5,2)
            ?? "            YTD debits     YTD credits"
            ? " Currently:"
            ?? ytddr PICTURE lc_numpic AT 15
            ?? ytdcr PICTURE lc_numpic AT 31
            ? "Calculated:"
            ?? ln_ytddr+ptddr PICTURE lc_numpic AT 15
            ?? ln_ytdcr+ptdcr PICTURE lc_numpic AT 31
            ?  SPACE(15)+REPLICATE("=",30)
            ? "Difference:"
            ?? ytddr-(ln_ytddr+ptddr) PICTURE lc_numpic AT 15
            ?? ytdcr-(ln_ytdcr+ptdcr) PICTURE lc_numpic AT 31
            ?
            REPLACE ytddr WITH ln_ytddr+ptddr, ;
                    ytdcr WITH ln_ytdcr+ptdcr
        ENDIF
        
        STORE ln_ytddr + ptddr TO ln_ytddr 
        STORE ln_ytdcr + ptdcr TO ln_ytdcr
        
    ENDSCAN

ENDDO

RETURN
*------------------------ End procedure l_chkytd_vfp

*------------------------ Procedure l_chkytd_sql
PROCEDURE l_chkytd_sql

*-- Let the user know what's going on
? "---------- Checking continuity of Year-to-date balances"
?

lc_tmpf1 = go_SQL.m_GetTempTableName(1)
lc_tmpf2 = go_SQL.m_GetTempTableName(2)

go_SQL.m_SQLSelect(" a_glbals.glacnt, " + ;
                   " a_glbals.yearprd, " + ;
                   " SUM(a_glbals1.ptddr) AS ytddr, " + ;
                   " SUM(a_glbals1.ptdcr) AS ytdcr " + ;
                   " FROM " + go_SQL.cmpa_glbals.sc_tablenamefull + ;
                   " a_glbals INNER JOIN " + ;
                     go_SQL.cmpa_glbals.sc_tablenamefull + ;
                   " a_glbals1 ON " + ;
                   " a_glbals.glacnt = a_glbals1.glacnt AND " + ;
                   " a_glbals1.yearprd <= a_glbals.yearprd AND " + ;
                   " LEFT(a_glbals1.yearprd, 4) = LEFT(a_glbals.yearprd, 4) " + ;
                   " INNER JOIN " + go_SQL.cmpA_glacnt.sc_TableNameFull + " a_glacnt " + ;
                   " ON a_glbals.glacnt = a_glacnt.glacnt " + ;
                   " WHERE LEFT(a_glacnt.gltype, 1) <> 'Y' " + ;
                   " GROUP BY a_glbals.glacnt, " + ;
                   " a_glbals.yearprd ", ;
                   "SQL TABLE", ;
                   lc_tmpf1)

go_SQL.so_CurrentAlias.m_CloseTable()

go_SQL.m_SQLSelect(" a_glbals.glacnt, a_glacnt.gldesc, a_glbals.yearprd, " + ;
                   " a_tmpf1.ytddr AS calytddr, a_tmpf1.ytdcr AS calytdcr, " + ;
                   " a_glbals.ytddr, a_glbals.ytdcr, a_glbals.ptddr, a_glbals.ptdcr " + ;
                   " FROM " + go_SQL.cmpA_glbals.sc_TableNameFull + " a_glbals " + ;
                   " INNER JOIN " + lc_tmpf1 + " a_tmpf1 " + ;
                   " ON a_glbals.glacnt = a_tmpf1.glacnt AND " + ;
                   " a_glbals.yearprd = a_tmpf1.yearprd " + ;
                   " INNER JOIN " + go_SQL.cmpA_glacnt.sc_TableNameFull + " a_glacnt " + ;
                   " ON a_glbals.glacnt = a_glacnt.glacnt " + ;
                   " WHERE a_glbals.ytddr <> a_tmpf1.ytddr OR " + ;
                   " a_glbals.ytdcr <> a_tmpf1.ytdcr", ;
                   "SQL TABLE", ;
                   lc_tmpf2)

go_SQL.so_CurrentAlias.m_CloseTable()

= g_opnfl(lc_tmpf2, "a_tmpf2", .t., .f.)

go_SQL.so_CurrentAlias.m_ScanBegin("F", ".t. = .t.")
DO WHILE go_SQL.so_CurrentAlias.m_ScanBulk()

  ln_errors = ln_errors + 1

  ? "Account " + ALLTRIM(glacnt) + " - " + gldesc
  ?
  ? SUBSTR(yearprd,1,4) + "-" + SUBSTR(yearprd,5,2)
  ?? "            YTD debits     YTD credits"
  ? " Currently:"
  ?? ytddr PICTURE lc_numpic AT 15
  ?? ytdcr PICTURE lc_numpic AT 31
  ? "Calculated:"
  ?? calytddr PICTURE lc_numpic AT 15
  ?? calytdcr PICTURE lc_numpic AT 31

  ?  SPACE(15) + REPLICATE("=",30)
  ? "Difference:"
  ?? ytddr - calytddr PICTURE lc_numpic AT 15
  ?? ytdcr - calytdcr PICTURE lc_numpic AT 31

  ?
ENDDO

go_SQL.cmpA_tmpf2.m_ScanEnd()
     
go_SQL.m_Execute(" UPDATE " + go_SQL.cmpA_glbals.sc_TableNameFull + ;
                 " SET ytddr = a_tmpf2.calytddr, " + ;
                 "     ytdcr = a_tmpf2.calytdcr " + ;
                 " FROM " + go_SQL.cmpA_glbals.sc_TableNameFull + " a_glbals " + ;
                 " INNER JOIN " + lc_tmpf2 + " a_tmpf2 " + ;
                 " ON a_glbals.glacnt = a_tmpf2.glacnt AND " + ;
                 "    a_glbals.yearprd = a_tmpf2.yearprd ", "")

go_SQL.cmpA_tmpf2.m_CloseTable()

go_SQL.m_DropTable(lc_tmpf1)
go_SQL.m_DropTable(lc_tmpf2)

RETURN
*------------------------ End procedure l_chkytd_sql

*------------------------ Procedure l_chkbals_vfp
PROCEDURE l_chkbals_vfp

*-- Let the user know what's going on
? "---------- Checking account balances"
?

PRIVATE ln_endbal, ;
        ln_begbal

go_SQL.m_TableChangeCurrent("a_glbals")
go_SQL.so_CurrentAlias.m_MoveRecord(ln_TopRec)


*-- Step through GLBALSxx and check to see if the Ending Balance
*-- of one period is the same as the beginning balance of the
*-- next period.
DO WHILE NOT go_SQL.so_CurrentAlias.m_IsEof()

    *-- Let the user know which account we're on
    WAIT WINDOW NOWAIT ALLTRIM(glacnt)+" "+a_glacnt->gldesc
    
    *-- Initialize the memory variables with values from the
    *-- current record
    STORE glacnt TO lc_glacnt
    STORE yearprd TO lc_yearprd
    
    *-- Reset the ending balance variable so it can be calculated
    STORE 0 TO ln_endbal
    
    *-- Calculate the ending balance of the current record
    DO l_ebalcalc
    
    *-- Go to the next record and compare the calculated
    *-- Ending Balance of the previous record with the
    *-- calculated Beginning Balance of this record
    go_SQL.so_CurrentAlias.m_MoveRecord(ln_NextRec)

    *-- Continue this drill until the next account is reached
    DO WHILE glacnt == lc_glacnt

        *-- Calculate the Beginning Balance
        STORE fybgbal+ytddr-ytdcr+ptdcr-ptddr TO ln_begbal

        *-- If they're not the same, check to see if the
        *-- difference is due to a Beginning Balance batch
        IF ln_begbal <> ln_endbal

            go_SQL.m_TableChangeCurrent("a_gldent")

            *-- Reset memory variables
            STORE 0 TO ln_bbbdr, ln_bbbcr
            
            *-- Insure we're at the 1st record in GLDENTxx
            *-- for the current account
            go_SQL.so_CurrentAlias.m_MoveRecord(ln_TopRec)
            go_SQL.so_CurrentAlias.m_Seek(lc_glacnt, "")
            
            *-- Step through all records in GLDENTxx for the current
            *-- account and period whose batch type in GLBTCHxx is "B"
            *-- for beginning balance
            go_SQL.so_CurrentAlias.m_ScanBegin("W", "glacnt = '" + lc_glacnt + "'")
            DO WHILE go_SQL.so_CurrentAlias.m_Scan()
              IF a_glbtch->btype=='B' AND yearprd==a_glbals->yearprd

                *-- Increment the correct variable based on whether
                *-- it's a debit or a credit
                IF credit
                    ln_bbbcr = ln_bbbcr + glamnt
                ELSE
                    ln_bbbdr = ln_bbbdr + glamnt
                ENDIF

              ENDIF  

            ENDDO
            go_SQL.so_CurrentAlias.m_ScanEnd()

            *-- Make GLBALSxx the active database again
            go_SQL.m_TableChangeCurrent("a_glbals")
            
            *-- Adjust the Beginning Balance of the current record
            *-- GLBALSxx by the Beginning Balance batch total
            STORE ln_begbal-ln_bbbdr+ln_bbbcr TO ln_begbal
            
            *-- Still doesn't balance?  Then there must be an error
            IF ABS(ln_begbal - ln_endbal) >= 0.01
                STORE ln_errors+1 TO ln_errors
                ?  "Account "+ALLTRIM(glacnt)+" - "+a_glacnt->gldesc
                ? SUBSTR(lc_yearprd,1,4)+"-"+SUBSTR(lc_yearprd,5,2)+;
                  " Ending Balance    = "
                ?? ln_endbal PICTURE lc_numpic
                ? SUBSTR(yearprd,1,4)+"-"+SUBSTR(yearprd,5,2)+;
                  " Beginning Balance = "
                ?? ln_begbal PICTURE lc_numpic
                ? SPACE(15)+"Difference = "
                ?? ln_begbal-ln_endbal PICTURE lc_numpic
                ?
                go_SQL.so_CurrentAlias.m_ReplaceBulk("fybgbal WITH fybgbal-(ln_begbal-ln_endbal)")
            ENDIF
        ENDIF

        *-- Having finished evaluating whether or not the Ending 
        *-- Balance of the previous record is the same as the 
        *-- Beginning Balance of this record, calcualte the Ending
        *-- Balance of this record, store it in memory then on to 
        *-- the next one and start the loop over
        DO l_ebalcalc
        STORE yearprd TO lc_yearprd
        go_SQL.so_CurrentAlias.m_MoveRecord(ln_NextRec)

    ENDDO

ENDDO

RETURN
*------------------------ End procedure l_chkbals_vfp
*------------------------ Procedure l_ebalcalc
*-- Called from l_chkbals
PROCEDURE l_ebalcalc

*-- If the year and period of the current record in GLBALSxx
*-- is equal to the last period of the current year, the ending
*-- balance depends on the type of account it is

PRIVATE ln_netinc
STORE 0 TO ln_netinc

*-- Make sure we're looking at the right file
go_SQL.m_TableChangeCurrent("a_glbals")

IF yearprd == lc_curyr+lc_fyperds

    DO CASE

        *-- Income Statement Account should have an ending
        *-- balance of 0.00
        CASE LEFT(a_glacnt->gltype,1) $ "SCXIT"
            STORE 0 TO ln_endbal

        *-- Default Retained Earnings account when Retained
        *-- Earnings are not departmentalized will include
        *-- the current years Net Income for all Income
        *-- Statement accounts
        CASE glacnt == lc_retearn .AND. .NOT. ll_depre
            go_SQL.m_TableChangeCurrent("a_glbals2")

            IF go_SQL.sc_SQLTypeMain <> "F"
              go_SQL.cmpA_glbals2.m_SetRelation("glacnt", "a_glacnt")
            ENDIF
            
            ln_actrec = go_SQL.cmpA_glacnt.m_GetRecno()

            go_SQL.cmpa_glbals2.m_Sum("fybgbal+ytddr-ytdcr", "ln_netinc", ;
                           "yearprd = '" + lc_curyr+lc_fyperds + "' AND LEFT(a_glacnt->gltype,1) $ 'SCXIT'")

            go_SQL.m_TableChangeCurrent("a_glbals")

            IF ln_actrec > 0
              go_SQL.cmpA_glacnt.m_MoveToRecno(ln_actrec)
            ENDIF

            IF go_SQL.sc_SQLTypeMain <> "F"
              go_SQL.cmpA_glbals2.m_SetRelation("")
            ENDIF

            STORE fybgbal+ytddr-ytdcr+yeclose+ln_netinc ;
              to ln_endbal

        *-- Retained Earnings accounts when departmentalized
        *-- will include the current years Net Income for
        *-- it's respective department only
        CASE LEFT(glacnt,la_glstru[1,1]) == ;
          LEFT(lc_retearn,la_glstru[1,1]) .AND. ;
          RIGHT(glacnt,24-ln_acdplen) == ;
          RIGHT(lc_retearn,24-ln_acdplen) .AND. ll_depre
            go_SQL.m_TableChangeCurrent("a_glbals2")

            IF go_SQL.sc_SQLTypeMain <> "F"
              go_SQL.cmpA_glbals2.m_SetRelation("glacnt", "a_glacnt")
            ENDIF

            ln_actrec = go_SQL.cmpA_glacnt.m_GetRecno()

            go_SQL.cmpa_glbals2.m_Sum("fybgbal+ytddr-ytdcr", "ln_netinc", ;
                           "yearprd = '" + lc_curyr+lc_fyperds + "' AND " + ;
                           "LEFT(a_glacnt->gltype,1) $ 'SCXIT' AND " + ;
                           "SUBSTR(glacnt,??la_glstru[2,2],??la_glstru[2,1]) = '" + SUBSTR(lc_glacnt,la_glstru[2,2],la_glstru[2,1]) + "'")

            IF go_SQL.sc_SQLTypeMain <> "F"
              go_SQL.cmpA_glbals2.m_SetRelation("")
            ENDIF
             
            go_SQL.m_TableChangeCurrent("a_glbals")

            IF ln_actrec > 0
              go_SQL.cmpA_glacnt.m_MoveToRecno(ln_actrec)
            ENDIF

            STORE fybgbal+ytddr-ytdcr+yeclose+ln_netinc ;
              to ln_endbal

        *-- Plain old ordinary Balance Sheet account
        OTHERWISE
            STORE fybgbal+ytddr-ytdcr+yeclose to ln_endbal

    ENDCASE

ELSE
    
    *-- Standard calculation for ending balance
    go_SQL.m_TableChangeCurrent("a_glbals")
    STORE fybgbal+ytddr-ytdcr+yeclose to ln_endbal
    
ENDIF

go_SQL.m_TableChangeCurrent("a_glbals")

RETURN
*------------------------ End procedure l_ebalcalc

*------------------------ Procedure l_chkttls
PROCEDURE l_chkttls

*-- Let the user know what's going on
? "---------- Checking field totals"
?

WAIT CLEAR

PRIVATE ln_tfybgbal, ;
        ln_tptddr, ;
        ln_tptdcr, ;
        ln_tytddr, ;
        ln_tytdcr, ;
        ln_tyeclose, ;
        ln_tdrdent, ;
        ln_tcrdent

STORE 0 TO ln_tfybgbal, ;
           ln_tptddr, ;
           ln_tptdcr, ;
           ln_tytddr, ;
           ln_tytdcr, ;
           ln_tyeclose, ;
           ln_tdrdent, ;
           ln_tcrdent

go_SQL.m_TableChangeCurrent("a_glbals")
go_SQL.so_currentalias.m_Sum("fybgbal, ptddr, ptdcr, ytddr, ytdcr, yeclose", ;
                     "ln_tfybgbal, ln_tptddr, ln_tptdcr, ln_tytddr, ln_tytdcr, ln_tyeclose")

go_SQL.m_TableChangeCurrent("a_gldent")
go_SQL.so_currentalias.m_Sum("glamnt", ;
                             "ln_tdrdent", ;
                             "credit = .f.")
go_SQL.so_currentalias.m_Sum("glamnt", ;
                             "ln_tcrdent", ;
                             "credit = .t.")

go_SQL.m_TableChangeCurrent("a_glbals")

*-- Does FYBGBAL sum to 0.00?
IF ABS(ln_tfybgbal) >= 0.01
    STORE ln_errors+1 TO ln_errors
    ?  "The FYBGBAL field should sum to 0.00 and it's: "
    ?? ln_tfybgbal PICTURE lc_numpic
    ?
ENDIF

*-- Does total PTDDR = total PTDCR?
IF ABS(ln_tptddr-ln_tptdcr) >= 0.01
    STORE ln_errors+1 TO ln_errors
    ?  "PTDDR minus PTDCR should sum to 0.00 and it's: "
    ?? ln_tptddr-ln_tptdcr PICTURE lc_numpic
    ?
ENDIF

*-- Does total YTDDR = total YTDCR?
IF ABS(ln_tytddr-ln_tytdcr) >= 0.01
    STORE ln_errors+1 TO ln_errors
    ?  "YTDDR minus YTDCR should sum to 0.00 and it's: "
    ?? ln_tytddr-ln_tytdcr PICTURE lc_numpic
    ?
ENDIF

*-- Does YECLOSE sum to 0.00?
IF ABS(ln_tyeclose) >= 0.01
    STORE ln_errors+1 TO ln_errors
    ?  "The YECLOSE field should sum to 0.00 and it's: "
    ?? ln_tyeclose PICTURE lc_numpic
    ?
ENDIF

*-- Does total Debits = total Credits in GLDENTxx?
IF ABS(ln_tdrdent-ln_tcrdent) >= 0.01
    STORE ln_errors+1 TO ln_errors
    ?  "Debits-Credits in GLDENT should be 0 and it's: "
    ?? ln_tdrdent-ln_tcrdent PICTURE lc_numpic
    ?
ENDIF

RETURN
*------------------------ End procedure l_chkttls

*------------------------ Procedure l_chkbals_sql
PROCEDURE l_chkbals_sql

*-- Let the user know what's going on
? "---------- Checking account balances"
?

PRIVATE ln_endbal, ;
        ln_begbal

go_SQL.m_TableChangeCurrent("a_glbals")
go_SQL.so_CurrentAlias.m_MoveRecord(ln_TopRec)

go_SQL.cmpA_glbals.m_SetRelation("glacnt", "a_glacnt")
go_SQL.cmpA_glbals.m_SetOrder("glacnt1")

*-- Step through GLBALSxx and check to see if the Ending Balance
*-- of one period is the same as the beginning balance of the
*-- next period.
go_SQL.cmpA_glbals.m_ScanBegin("F", "LEFT(a_glacnt.gltype, 1) <> 'Y'")
DO WHILE go_SQL.cmpA_glbals.m_ScanBulk()

    *-- Let the user know which account we're on
    WAIT WINDOW NOWAIT ALLTRIM(glacnt)+" "+a_glacnt->gldesc
    
    *-- Initialize the memory variables with values from the
    *-- current record
    STORE glacnt TO lc_glacnt
    STORE yearprd TO lc_yearprd
    
    *-- Reset the ending balance variable so it can be calculated
    STORE 0 TO ln_endbal
    
    *-- Calculate the ending balance of the current record
    DO l_ebalcalc
    
    *-- Go to the next record and compare the calculated
    *-- Ending Balance of the previous record with the
    *-- calculated Beginning Balance of this record
    SKIP IN a_glbals

    *-- Continue this drill until the next account is reached
    DO WHILE glacnt == lc_glacnt

        *-- Calculate the Beginning Balance
        STORE fybgbal+ytddr-ytdcr+ptdcr-ptddr TO ln_begbal

        *-- If they're not the same, check to see if the
        *-- difference is due to a Beginning Balance batch
        IF ln_begbal <> ln_endbal

            go_SQL.m_TableChangeCurrent("a_gldent")

            *-- Reset memory variables
            STORE 0 TO ln_bbbdr, ln_bbbcr
            
            *-- Insure we're at the 1st record in GLDENTxx
            *-- for the current account

            *-- SUM up records in GLDENTxx for the current
            *-- account and period whose batch type in GLBTCHxx is "B"
            *-- for beginning balance
            lc_tmpf1 = go_SQL.m_GetTempTableName(1)

            go_SQL.m_SQLSelect(" ISNULL((SELECT SUM(CASE WHEN a_gldent.credit = .t. THEN a_gldent.glamnt ELSE 0.00 END) " + ;
                   "  FROM " + go_SQL.cmpA_gldent.sc_TableNameFull + " a_gldent " + ;
                   "  INNER JOIN " + go_SQL.cmpA_glbtch.sc_TableNameFull + " a_glbtch " + ;
                   "  ON a_glbtch.batchno = a_gldent.batchno " + ;
                   "  WHERE a_gldent.glacnt = ??a_glbals.glacnt AND " + ;
                   "        a_gldent.yearprd = ??a_glbals.yearprd AND " + ;
                   "        a_glbtch->btype = 'B'), 0.00) " + ;
                   " AS bbbcr, " + ;
                   " ISNULL((SELECT SUM(CASE WHEN a_gldent.credit = .f. THEN a_gldent.glamnt ELSE 0.00 END) " + ;
                   "  FROM " + go_SQL.cmpA_gldent.sc_TableNameFull + " a_gldent " + ;
                   "  INNER JOIN " + go_SQL.cmpA_glbtch.sc_TableNameFull + " a_glbtch " + ;
                   "  ON a_glbtch.batchno = a_gldent.batchno " + ;
                   "  WHERE a_gldent.glacnt = ??a_glbals.glacnt AND " + ;
                   "        a_gldent.yearprd = ??a_glbals.yearprd AND " + ;
                   "        a_glbtch->btype = 'B'), 0.00) " + ;
                   " AS bbbdr " + ;
                   " FROM " + go_SQL.cmpA_glbals.sc_TableNameFull + " a_glbals " + ;
                   " INNER JOIN " + go_SQL.cmpA_glacnt.sc_TableNameFull + " a_glacnt " + ;
                   " ON a_glbals.glacnt = a_glacnt.glacnt " + ;
                   " WHERE LEFT(a_glacnt.gltype, 1) <> 'Y' AND "  + ;
                   "       a_glbals.glacnt = ??a_glbals.glacnt AND " + ;
                   "       a_glbals.yearprd = ??a_glbals.yearprd ",  ;
                   "SQL TABLE", ;
                   lc_tmpf1)

            ln_bbbdr = bbbdr
            ln_bbbcr = bbbcr
            
            *-- Close/Drop temporary table
            go_SQL.so_CurrentAlias.m_CloseTable()
            go_SQL.m_DropTable(lc_tmpf1)

            *-- Make GLBALSxx the active database again
            go_SQL.m_TableChangeCurrent("a_glbals")
            
            *-- Adjust the Beginning Balance of the current record
            *-- GLBALSxx by the Beginning Balance batch total
            STORE ln_begbal-ln_bbbdr+ln_bbbcr TO ln_begbal
            
            *-- Still doesn't balance?  Then there must be an error
            IF ABS(ln_begbal - ln_endbal) >= 0.01
                STORE ln_errors+1 TO ln_errors

                *-- Locate the record in GLACNT
                go_SQL.cmpA_glacnt.m_Seek(a_glbals.glacnt, "")

                ?  "Account "+ALLTRIM(glacnt)+" - "+a_glacnt->gldesc
                ? SUBSTR(lc_yearprd,1,4)+"-"+SUBSTR(lc_yearprd,5,2)+;
                  " Ending Balance    = "
                ?? ln_endbal PICTURE lc_numpic
                ? SUBSTR(yearprd,1,4)+"-"+SUBSTR(yearprd,5,2)+;
                  " Beginning Balance = "
                ?? ln_begbal PICTURE lc_numpic
                ? SPACE(15)+"Difference = "
                ?? ln_begbal-ln_endbal PICTURE lc_numpic
                ?
                go_SQL.so_CurrentAlias.m_ReplaceBulk("fybgbal WITH fybgbal-(ln_begbal-ln_endbal)")
            ENDIF
        ENDIF

        *-- Having finished evaluating whether or not the Ending 
        *-- Balance of the previous record is the same as the 
        *-- Beginning Balance of this record, calcualte the Ending
        *-- Balance of this record, store it in memory then on to 
        *-- the next one and start the loop over
        DO l_ebalcalc
        STORE yearprd TO lc_yearprd
        SKIP IN a_glbals

    ENDDO

    *-- If next account, go to previous record, 
    *-- Since m_ScanBulk() will again skip a record
    IF NOT EOF("a_glbals")
      SKIP -1 IN a_glbals
    ELSE
      *-- No more records to process
      EXIT 
    ENDIF
    
ENDDO
go_SQL.cmpA_glbals.m_ScanEnd()

RETURN
*------------------------ End procedure l_chkbals_sql
